Imports System
Imports System.Data
Imports System.Data.OleDb

Module criaSP

    Sub Main()

        ProcedimentosArmazenadosProdutos()

    End Sub

    ' Procedimentos Armazenados a serem incluidos no banco de dados
    Sub ProcedimentosArmazenadosProdutos()
        Dim strSQL As String

        ' spListaProdutos - retorna todos os registros da tabela produtos
        strSQL = "CREATE PROC spListaProdutos AS SELECT * FROM Products;"
        criaProcedimentoArmazeando(strSQL)

        ' spDeletaProduto - Efetua a excluso de uma linha da tabela Products com base 
        ' em um cdigo de produto informado como parmetro
        strSQL = "CREATE PROC spDeletaProduto(codigoProduto LONG) " & _
               "AS DELETE FROM Products WHERE ProductID = codigoProduto;"
        criaProcedimentoArmazeando(strSQL)

        ' spIncluiProduto - Inclui uma linha na tabela Products
        'strSQL = "CREATE PROC procProductsAddItem(inProductName VARCHAR(40), inSupplierID LONG, inCategoryID LONG) " & _
        '       "AS INSERT INTO Products (ProductName, SupplierID, CategoryID) Values (inProductName, inSupplierID, inCategoryID);"

        strSQL = "CREATE PROC spIncluiProduto(nomeProduto VARCHAR(40), codFornecedor LONG, codCategoria LONG, quantidade VARCHAR(20), " & _
                "precoUnitario MONEY, uniEstoque LONG, uniPedido LONG, nivelUnidade LONG, continuado byte) " & _
                "AS INSERT INTO Products (ProductName, SupplerID, CategoryID, QuantityPerUnit, UnitPrice, UnitsInStock, UnitsOnOrder, ReorderLevel, Discontinued) " & _
                "VALUES (nomeProduto, codFornecedor, codCategoria, quantidade, precoUnitario, uniEstoque, uniPedido, nivelUnidade, continuado)"
        criaProcedimentoArmazeando(strSQL)

        ' spAtualizaProdutos - atualiza itens da tabela Products
        strSQL = "CREATE PROC spAtualizaProdutos(codigoProduto LONG, nomeProduto VARCHAR(40)) " & _
               "AS UPDATE Products SET ProductName = nomeProduto WHERE ProductID = codigoProduto;"
        criaProcedimentoArmazeando(strSQL)


    End Sub

    ' Executa a criao dos procedimentos armazenados
    Sub criaProcedimentoArmazeando(ByVal strSQL As String)
        Dim con As OleDbConnection
        Dim cmd As OleDbCommand = New OleDbCommand
        Dim da As OleDbDataAdapter

        ' Verifique se a localizao do banco de dados  mesma no seu ambiente
        Dim sConStr As String = "PROVIDER=Microsoft.Jet.OLEDB.4.0;Data Source=d:\teste\Northwind.mdb"

        con = New OleDbConnection(sConStr)

        cmd.Connection = con
        cmd.CommandText = strSQL

        Try
            con.Open()
            cmd.ExecuteNonQuery()
        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            con.Close()
        End Try
    End Sub


End Module
